/*-----------------------------------------------------------------------------
 * load.c for EmuZ-2000 ver0.02 Copyright (c) 2002 TSUNEOKA shinji
 * modified by Koji Morishita (2012.3.26)
 *
 * Based tapeload.cpp ver0.13a Copyright (c) 1999-2000 Takeshi Maruyama
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
-----------------------------------------------------------------------------*/
#include "load.h"

//CSUM_SIZE0Ȃ`FbNTċL^
//CSUM_SIZE2Ȃ`FbNT܂߂ċL^
//added by koji morishita
#define CSUM_SIZE			0
#define TEXT_SIZE     256+CSUM_SIZE

  BOOL  _fDebug = DEFAULT_DEBUG;  /* DebugModeFlag */
  BOOL  _fSjis  = DEFAULT_SJIS;   /* HeaderFileNameCodeModeFlag */

/*-----------------------------------------------------------------------------
[`    ]    DebugPrintf
[    ]    lpszFmt ... tH[}bg
                      ... p[^
[    ]    fobOOo͂
[ӎ]    Oϐ BOOL _fDebug œ؂ւ
[  l]    Ȃ
-----------------------------------------------------------------------------*/
VOID cdecl DebugPrintf(LPSTR lpszFmt, ...)
{
  if(_fDebug == TRUE){
    LPSTR *lppParam = ((LPSTR*)&lpszFmt) + 1;
    vfprintf(stderr, lpszFmt, (LPSTR)lppParam);
  }
}

/*-----------------------------------------------------------------------------
[`    ]    DisplayErrorMessage
[    ]    lpcszFuncName ... w|C^
              dwErrorCode  ... G[R[h
[    ]    G[bZ[W\
[ӎ]
[  l]    Ȃ
-----------------------------------------------------------------------------*/
VOID DisplayErrorMessage(LPCSTR lpcszFuncName, DWORD dwErrorCode)
{
  LPSTR lpszErrorText = NULL;

  /* VXẽG[bZ[Wo͂ */
  FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER
      | FORMAT_MESSAGE_FROM_SYSTEM
      | FORMAT_MESSAGE_ARGUMENT_ARRAY,
      NULL, dwErrorCode, LANG_NEUTRAL, (LPSTR)&lpszErrorText, 0, NULL);

  fprintf(stderr, "%s: %s", lpcszFuncName, lpszErrorText);

  LocalFree((HLOCAL)lpszErrorText);
}

/*-----------------------------------------------------------------------------
[`    ]    ReleaseMappingFile
[    ]    Ȃ
[    ]    t@C}bsO
[ӎ]
[  l]    Ȃ
-----------------------------------------------------------------------------*/
VOID ReleaseMappingFile(LPMAPPING lpMap)
{
  if(lpMap == NULL){
    return;
  }

  if(lpMap->lpszFile){
    UnmapViewOfFile(lpMap->lpszFile);
  }
  if(lpMap->hMap){
    CloseHandle(lpMap->hMap);
  }
  if(lpMap->hFile){
    CloseHandle(lpMap->hFile);
  }

  LocalFree(lpMap);
}

/*-----------------------------------------------------------------------------
[`    ]    CreateMappingFile
[    ]    lpcszFileName ... t@C
[    ]    t@C}bsO쐬
[ӎ]    QƐpō쐬
[  l]    Ȃ
-----------------------------------------------------------------------------*/
LPMAPPING CreateMappingFile(LPCSTR lpcszFileName)
{
  LPMAPPING lpMap      = NULL;
  DWORD   dwFileSize = 0L;
  LRESULT   lResult = ERROR_SUCCESS;

  if((lpMap = LocalAlloc(LPTR, sizeof(MAPPING))) == NULL){
    DisplayErrorMessage("LocalAlloc", GetLastError());
    return NULL;
  }

  __try{
    lpMap->hFile = CreateFile(lpcszFileName,
      GENERIC_READ, 0, NULL, OPEN_EXISTING, 0, NULL);
    if(lpMap->hFile == INVALID_HANDLE_VALUE){
      lResult = GetLastError();
      DisplayErrorMessage(lpcszFileName, lResult);
			#ifdef __BORLANDC__
			goto
			#endif
			__leave;
    }
    lpMap->hMap = CreateFileMapping(
        lpMap->hFile, NULL, PAGE_READONLY, 0, 0, NULL);
    if(lpMap->hMap == INVALID_HANDLE_VALUE){
      lResult = GetLastError();
      DisplayErrorMessage("CreateFileMapping", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    lpMap->lpszFile = MapViewOfFile(lpMap->hMap, FILE_MAP_READ, 0, 0, 0);
    if(lpMap->lpszFile == NULL){
      lResult = GetLastError();
      DisplayErrorMessage("MapViewOfFile", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }

    lpMap->dwFileSize = GetFileSize(lpMap->hFile, NULL);
  }
  __finally{
    if(lResult != ERROR_SUCCESS){
      ReleaseMappingFile(lpMap);
      lpMap = NULL;
    }
  }
	#ifdef __BORLANDC__
	__leave:
	#endif
  return lpMap;
}

/*-----------------------------------------------------------------------------
[`    ]    CodeToChar
[    ]    bCode ... R[h
[    ]    \𓾂
[ӎ]    Oϐ BOOL _fSjis ŏo̓R[h؂ւ
[  l]    ANK܂͂QoCgR[h
-----------------------------------------------------------------------------*/
LPCSTR CodeToChar(BYTE bCode)
{
  static char szCode[3];
  unsigned int uKey;

  /* R[h\ MZ-2000LN^R[hC[W */
  static LPCSTR lpcszAsciiCodeAnk = {
    " !\x22#$%&\x27()*+,-./"/* 20 */
    "0123456789:;<=>?"    /* 30 */
    "@ABCDEFGHIJKLMNO"    /* 40 */
    "PQRSTUVWXYZ[\\]^*"   /* 50 */
    "*abcdefghijklmno"    /* 60 */
    "pqrstuvwxyz{|}~."    /* 70 */
    "................"    /* 80 */
    ".\\.............."   /* 90 */
    ".WX֯"    /* A0 */
    "*"    /* B0 */
    ""    /* C0 */
    ""    /* D0 */
    "ZABCDEFGHIJKLMNO"    /* E0 */
    "0123456789PQRST."    /* F0 */
  };

  static LPCSTR lpcszAsciiCodeSjis = {
    "  Ihfij{C|D^"  /* 20 */
    "OPQRSTUVWXFGH"  /* 30 */
    "`abcdefghijklmn"  /* 40 */
    "opqrstuvwxym_nOP"  /* 50 */
    "L"  /* 60 */
    "obp`"  /* 70 */
    ""  /* 80 */
    ""  /* 90 */
    "Buvvw@BDFHb"  /* A0 */
    "ACEGIJLNPRTVXZ\"  /* B0 */
    "^`cegijklmnqtwz}"  /* C0 */
    "~JK"  /* D0 */
    "y`abcdefghijklmn"  /* E0 */
    "OPQRSTUVWXopqrs"  /* F0 */
  };

  if(bCode < 0x20){
    bCode = 0x20;
  }
  bCode -= 0x20;

  uKey = bCode;
  if(_fSjis == FALSE){  /* ANKŕ\ */
    *szCode     = *(lpcszAsciiCodeAnk + uKey);
    *(szCode+1) = '\0';
  }
  else{         /* S-JISŕ\ */
    uKey *= 2;
    *szCode     = *(lpcszAsciiCodeSjis + uKey);
    *(szCode+1) = *(lpcszAsciiCodeSjis + uKey+1);
    *(szCode+2) = '\0';
  }

  return szCode;
}

/*-----------------------------------------------------------------------------
[`    ]    PrintHeader
[    ]    lpmzh ... MZe[vwb_
[    ]    wb_̏\
[ӎ]
[  l]    Ȃ
-----------------------------------------------------------------------------*/
VOID PrintHeader(LPMZTAPEHEADER lpmzh)
{
  int iLen;

  printf("FOUND ");
  for(iLen = 0; iLen < MZFILENAMELEN; iLen++){
    BYTE b = lpmzh->szFileName[iLen];
    if(b < 0x20){
      break;
    }
    printf("%s", CodeToChar(b));
  }
  putchar('\n');

  printf("Mode $%02X(%s)", lpmzh->bMode,
      (lpmzh->bMode == 0x01) ? "Binary" : "BASIC or OtherLanguage");
  printf(" Size $%04X StartAdr $%04X JumpAdr $%04X\n",
      lpmzh->wSize, lpmzh->wStartAddress, lpmzh->wJumpAddress);
}

/*-----------------------------------------------------------------------------
[`    ]    CheckWaveFileFormat
[    ]    lpbRecord ... Wavet@C
[    ]    t@CtH[}bg`FbN
[ӎ]
[  l]    Ȃ
-----------------------------------------------------------------------------*/
LPBYTE CheckWaveFileFormat(LPBYTE lpbRecord, LPBYTE lpbTail)
{
  LPCHUNK lpChunk        = NULL;
  LPSTR lpszFormatType = NULL;
  LRESULT lResult        = ERROR_SUCCESS;

  lpChunk = (LPCHUNK)lpbRecord;
  lpbRecord += sizeof(CHUNK);
  if(strncmp(lpChunk->cId, "RIFF", 4) != 0){
    lResult = ERROR_INVALID_DATA;
    DisplayErrorMessage("RIFF Format", lResult);
    SetLastError(lResult);
    return NULL;
  }

  lpszFormatType = lpbRecord;
  lpbRecord = lpszFormatType + 4;
  if(strncmp(lpszFormatType, "WAVE", 4) != 0){
    lResult = ERROR_INVALID_DATA;
    DisplayErrorMessage("WAVE Format", lResult);
    SetLastError(lResult);
    return NULL;
  }
  while(lpbRecord <= lpbTail){
    lpChunk = (LPCHUNK)lpbRecord;
    lpbRecord += sizeof(CHUNK);
    if(strncmp(lpChunk->cId, "fmt ", 4) == 0){
      LPWAVEFORMATEX lpwf = (LPWAVEFORMATEX)lpbRecord;
      lpbRecord += lpChunk->dwSize;
      DebugPrintf("Channels   : %d ch\n", lpwf->nChannels);
      DebugPrintf("Frequency  : %d Hz\n", lpwf->nSamplesPerSec);

      if(lpwf->nChannels != 1){
        lResult = ERROR_INVALID_DATA;
        DisplayErrorMessage("Channel is not Mono", lResult);
        break;
      }
      if(lpwf->nSamplesPerSec != 22050){
        lResult = ERROR_INVALID_DATA;
        DisplayErrorMessage("Frequency is not 22.05KHz", lResult);
        break;
      }
    }
    else if(strncmp(lpChunk->cId, "data", 4) == 0){
      break;
    }
    else{
      lpbRecord += lpChunk->dwSize;
    }
  }

  if(lpbRecord >= lpbTail){
    lResult = ERROR_NO_MORE_ITEMS;
    DisplayErrorMessage("WaveFile", lResult);
    return NULL;
  }

  SetLastError(lResult);
  return lpbRecord;
}

/*-----------------------------------------------------------------------------
[`    ]    GetBit
[    ]    lpOpts ... 
[    ]    Wavet@CBitf[^擾
[ӎ]
[  l]    IFrbg  ُIFEOF
-----------------------------------------------------------------------------*/
int GetBit(LPOPTIONS lpOpts)
{
  BYTE    bAudio;
  static int  iBitSave = BIT_L;
  int     iBit     = lpOpts->iHold;

  if(lpOpts->lpbData >= lpOpts->lpbTail){
    return EOF;
  }

  bAudio = *(lpOpts->lpbData);
  lpOpts->lpbData++;

  if(bAudio <= (THRESHOLD_BASE - lpOpts->iThreshold)){
    iBit = iBitSave = BIT_L;
  }
  else if(bAudio >= (THRESHOLD_BASE + lpOpts->iThreshold)){
    iBit = iBitSave = BIT_H;
  }
  else{
    /* srbg̏ꍇ */
    if(lpOpts->fBitSave == TRUE){
      iBit = iBitSave;    /* O̒l */
    }
  }

  if(lpOpts->fDisplayBits){
    putchar(iBit ? '*' : '.');  /* rbg_v */
  }

  return iBit;
}

/*-----------------------------------------------------------------------------
[`    ]    Wait
[    ]    lpOpts ... 
[    ]    Wavef[^PoCgPʎԂŃf[^ǂݔ΂
[ӎ]    1200{[ ... iWait=7, 2000{[ ... iWait=4
[  l]    IFŌɎ擾Bitl  ُIFEOF
-----------------------------------------------------------------------------*/
int Wait(LPOPTIONS lpOpts)
{
  int iBit, iWait;
  int iResult = 0;

  /* Wait320us */
  for(iWait = 0; iWait < lpOpts->iWait; iWait++){
    if((iBit = GetBit(lpOpts)) == EOF){
      return EOF;
    }
    if(iWait >= (lpOpts->iWait - 1)){
      iResult = iBit;
    }
  }

  return iResult;
}

/*-----------------------------------------------------------------------------
[`    ]    Edge
[    ]    lpOpts ... 
[    ]    g`̃GbWo
[ӎ]
[  l]    IFf[^  ُIFEOF
-----------------------------------------------------------------------------*/
int Edge(LPOPTIONS lpOpts)
{
  int iBit;
  int iHigh = BIT_L;
  int iLow  = BIT_L;

  if(lpOpts->fReverse == FALSE){
    /* Normal */
    while((iBit = GetBit(lpOpts)) != BIT_L){  /* WAIT 'L' */
      if(iBit == EOF){
        return EOF;
      }
      iHigh++;
    }
    while((iBit = GetBit(lpOpts)) != BIT_H){  /* WAIT 'H' */
      if(iBit == EOF){
        return EOF;
      }
      iLow++;
    }
  }
  else{
    /* Reverse */
    while((iBit = GetBit(lpOpts)) != BIT_H){  /* WAIT 'H' */
      if(iBit == EOF){
        return EOF;
      }
      iLow++;
    }
    while((iBit = GetBit(lpOpts)) != BIT_L){  /* WAIT 'L' */
      if(iBit == EOF){
        return EOF;
      }
      iHigh++;
    }
  }

  return ((iHigh << 16) | iLow);
}

/*-----------------------------------------------------------------------------
[`    ]    GetByte
[    ]    lpOpts ... 
[    ]    PoCg̔g`XL
[ӎ]
[  l]    IFf[^  ُIFEOF
-----------------------------------------------------------------------------*/
int GetByte(LPOPTIONS lpOpts, LPINT lpiSumDigit)
{
  int iBits, iBit;
  int iData = BIT_L;

  for(iBits = 0; iBits < 8; iBits++){
    iData <<= BIT_H;
    if(Edge(lpOpts) == EOF){
      return EOF;
    }
    if(Wait(lpOpts) == EOF){
      return EOF;
    }
    if((iBit = GetBit(lpOpts)) == EOF){
      return EOF;
    }
    if(iBit == (lpOpts->fReverse ^ BIT_H)){
      iData |= BIT_H;
      (*lpiSumDigit)++;
    }
  }
  if(Edge(lpOpts) == EOF){
    return EOF;
  }

  if(lpOpts->fDisplayDump){
    fprintf(stderr, "$%02X ", iData); /* 16i_v\ */
  }
  return iData;
}

/*-----------------------------------------------------------------------------
[`    ]    FindTone
[    ]    lpOpts ... 
              iTone  ... g[JEgl
[    ]    f[^Jng[XL
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT FindTone(LPOPTIONS lpOpts, int iTone)
{
  int   iBit;
  int   iCount;
  BOOL  fSuccess = TRUE;

  do{
    fSuccess = FALSE;
    for(iCount = 0; iCount < 100; iCount++){
      if(Edge(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if(Wait(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if((iBit = GetBit(lpOpts)) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if(iBit == (lpOpts->fReverse ^ BIT_H)){   /* 1 */
        fSuccess = TRUE;
        break;
      }
    }
  }
  while(fSuccess);
  DebugPrintf("Tone       : Done GapCheck\n");

  do{
    fSuccess = FALSE;
    for(iCount = 0; iCount < (iTone >> 8); iCount++){
      if(Edge(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if(Wait(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if((iBit = GetBit(lpOpts)) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if(iBit == (lpOpts->fReverse & BIT_H)){   /* 0 */
        fSuccess = TRUE;
        break;
      }
    }
    if(fSuccess == FALSE){
      for(iCount = 0; iCount < (iTone & 255); iCount++){
        if(Edge(lpOpts) == EOF){
          return ERROR_NO_MORE_ITEMS;
        }
        if(Wait(lpOpts) == EOF){
          return ERROR_NO_MORE_ITEMS;
        }
        if((iBit = GetBit(lpOpts)) == EOF){
          return ERROR_NO_MORE_ITEMS;
        }
        if(iBit == (lpOpts->fReverse ^ BIT_H)){   /* 1 */
          fSuccess = TRUE;
          break;
        }
      }
    }
  }
  while(fSuccess);
  DebugPrintf("Tone       : Done TMark\n");

  if(Edge(lpOpts) == EOF){
    return ERROR_NO_MORE_ITEMS;
  }
  return ERROR_SUCCESS;
}

/*-----------------------------------------------------------------------------
[`    ]    GetBlock
[    ]    lpOpts  ... 
              iTone   ... g[JE^l
              lpbBuff ... f[^擾obt@
              dwSize  ... obt@TCY
[    ]    f[^ubN擾
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT GetBlock(LPOPTIONS lpOpts, int iTone, LPBYTE lpbBuff, DWORD dwSize)
{
  int   iScan;
  int   iBit, iData;
  int   iSumDigit, iSum, iSumReaded;
  LPBYTE  lpb, lpbTail;
  LRESULT lResult = ERROR_SUCCESS;

  if((lResult = FindTone(lpOpts, iTone)) != ERROR_SUCCESS){
    return lResult;
  }

  for(iScan = 1; iScan <= 2; iScan++){  /* G[ɃgCs */
    do{
      if(Edge(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if(Wait(lpOpts) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      if((iBit = GetBit(lpOpts)) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
    }
    while(iBit == lpOpts->fReverse);    /* 0 */

    iSumDigit = 0;
    lpb = lpbBuff;
    lpbTail = lpbBuff + dwSize;
    for(lpb = lpbBuff; lpb < lpbTail; lpb++){
      if((iData = GetByte(lpOpts, &iSumDigit)) == EOF){
        return ERROR_NO_MORE_ITEMS;
      }
      *lpb = (BYTE)iData;
    }
    iSum = (iSumDigit & 0xffff);

    if((iData = GetByte(lpOpts, &iSumDigit)) == EOF){
      return ERROR_NO_MORE_ITEMS;
    }
    iSumReaded = iData << 8;
    if((iData = GetByte(lpOpts, &iSumDigit)) == EOF){
      return ERROR_NO_MORE_ITEMS;
    }
    iSumReaded += iData;

    if(lpOpts->fTextMode==TRUE){      // added by Koji Morishita.
      //printf("TextMode CheckSum($%04X/Wanted$%04X)\n", iSum, iSumReaded);
      break;
    }else
    if((iSum != iSumReaded)&&(lpOpts->fForceMode==FALSE)){ // added by koji Morishita
      printf("CheckSum Counted $%04X, Wanted $%04X\n", iSum, iSumReaded);
      if(iScan == 1){
        printf("Retry\n");
      }
      else{
          return ERROR_INVALID_DATA;
        }
      }
    else{
      break;
    }
  }

  return ERROR_SUCCESS;
}

/*-----------------------------------------------------------------------------
[`    ]    DecodeHeader
[    ]    lpOpts ... IvV
              lpszt  ... o̓obt@
[    ]    wb_fR[h
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT DecodeHeader(LPOPTIONS lpOpts, LPMZTAPE lpmzt)
{
  LPBYTE lpbBuff = (LPBYTE)&(lpmzt->header);
  DWORD dwSize = sizeof(MZTAPEHEADER);
  LRESULT lResult;

  lResult = GetBlock(lpOpts, TONE_HEADER, lpbBuff, dwSize);
  if(lResult != ERROR_SUCCESS){
    DisplayErrorMessage("DecodeHeader", lResult);
    return lResult;
  }

  PrintHeader(&(lpmzt->header));
  return ERROR_SUCCESS;
}

/*-----------------------------------------------------------------------------
[`    ]    DecodeBody
[    ]    lpOpts ... IvV
              lpszt  ... o̓obt@
[    ]    {̕fR[h
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT DecodeBody(LPOPTIONS lpOpts, LPMZTAPE lpmzt)
{
  LPBYTE lpbBuff = (LPBYTE)&(lpmzt->body.bBody);
  DWORD dwSize = lpmzt->header.wSize;
  LRESULT lResult;

  lResult = GetBlock(lpOpts, TONE_BODY, lpbBuff, dwSize);
  if(lResult != ERROR_SUCCESS){
    DisplayErrorMessage("DecodeBody", lResult);
    return lResult;
  }
  lpmzt->body.dwSize = dwSize;

  return ERROR_SUCCESS;
}

/*-----------------------------------------------------------------------------
[`    ]    CreateImageFile
[    ]    lpOpts ... IvV
              lpszt  ... o̓obt@
[    ]    C[Wt@C𐶐
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT CreateImageFile(LPOPTIONS lpOpts, LPMZTAPE lpmzt)
{
  HANDLE  hFileHead = NULL;
  HANDLE  hFileBody = NULL;
  HANDLE  hFileMzt  = NULL;
  DWORD dwWritten = 0;
  DWORD dwMztSize = 0;
  BOOL  fSuccess  = FALSE;
  LRESULT lResult   = ERROR_SUCCESS;

  __try{
    if(lpOpts->fDatFile == TRUE){
      /* wb_t@C */
      printf("Create %s\n", lpOpts->szHeaderFile);
      hFileHead = CreateFile(lpOpts->szHeaderFile,
        GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
      if(hFileHead == INVALID_HANDLE_VALUE){
        lResult = GetLastError();
        DisplayErrorMessage("CreateFile", lResult);
        hFileHead = NULL;
				#ifdef __BORLANDC__
				goto
				#endif
        __leave;
      }
      fSuccess = WriteFile(hFileHead, &(lpmzt->header),
          sizeof(MZTAPEHEADER), &dwWritten, NULL);
      if(fSuccess == FALSE){
        lResult = GetLastError();
        DisplayErrorMessage("WriteFile", lResult);
				#ifdef __BORLANDC__
				goto
				#endif
        __leave;
      }
      DebugPrintf("Size       : %u bytes\n", dwWritten);
    }

    if(lpmzt->body.dwSize == 0){
			#ifdef __BORLANDC__
			goto
			#endif
      __leave; /* wb_̂ݎ擾ł */
    }

    if(lpOpts->fDatFile == TRUE){
      /* {̕t@C */
      printf("Create %s\n", lpOpts->szBodyFile);
      hFileBody = CreateFile(lpOpts->szBodyFile,
        GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
      if(hFileBody == INVALID_HANDLE_VALUE){
        lResult = GetLastError();
        DisplayErrorMessage("CreateFile", lResult);
        hFileBody = NULL;
				#ifdef __BORLANDC__
				goto
				#endif
        __leave;
      }
      fSuccess = WriteFile(hFileBody, &(lpmzt->body.bBody),
          lpmzt->body.dwSize, &dwWritten, NULL);
      if(fSuccess == FALSE){
        lResult = GetLastError();
        DisplayErrorMessage("WriteFile", lResult);
				#ifdef __BORLANDC__
				goto
				#endif
        __leave;
      }
      DebugPrintf("Size       : %u bytes\n", dwWritten);
    }

    /* MZTt@C */
    printf("Create %s\n", lpOpts->szMztFile);
    hFileMzt = CreateFile(lpOpts->szMztFile,
      GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, NULL);
    if(hFileMzt == INVALID_HANDLE_VALUE){
      lResult = GetLastError();
      DisplayErrorMessage("CreateFile", lResult);
      hFileMzt = NULL;
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    if(lpOpts->fTextMode == TRUE){					//vOt@C̏ꍇ
      lpmzt->header.wSize=lpmzt->bodySize;	//ۑl߂
      fSuccess = WriteFile(hFileMzt,
          &(lpmzt->header), sizeof(MZTAPEHEADER), &dwWritten, NULL);
      lpmzt->header.wSize=TEXT_SIZE;        //܂߂
    }else{
      fSuccess = WriteFile(hFileMzt,
          &(lpmzt->header), sizeof(MZTAPEHEADER), &dwWritten, NULL);
    }
    if(fSuccess == FALSE){
      lResult = GetLastError();
      DisplayErrorMessage("WriteFile(Head)", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    dwMztSize = dwWritten;
    fSuccess = WriteFile(hFileMzt,
        &(lpmzt->body.bBody), lpmzt->body.dwSize, &dwWritten, NULL);
    if(fSuccess == FALSE){
      lResult = GetLastError();
      DisplayErrorMessage("WriteFile(Body)", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    dwMztSize += dwWritten;
    DebugPrintf("Size       : %u bytes\n", dwMztSize);
  }
  __finally{
    if(hFileHead){
      CloseHandle(hFileHead);
    }
    if(hFileBody){
      CloseHandle(hFileBody);
    }
    if(hFileMzt){
      CloseHandle(hFileMzt);
    }
  }
	#ifdef __BORLANDC__
	__leave:
	#endif
  return lResult;
}

/*-----------------------------------------------------------------------------
[`    ]    AppendImageFile
[    ]    lpOpts ... IvV
              lpszt  ... o̓obt@
[    ]    C[Wt@C𐶐
[ӎ]    MZT݂̂̑Ή
[  l]    IR[h
[    ]    ver0.03kmŒǉFunctionł
-----------------------------------------------------------------------------*/
LRESULT AppendImageFile(LPOPTIONS lpOpts, LPMZTAPE lpmzt){
  HANDLE  hFileMzt  = NULL;
  DWORD dwWritten = 0;
  DWORD dwMztSize = 0;
  BOOL  fSuccess  = FALSE;
  LRESULT lResult   = ERROR_SUCCESS;

  __try{
    /* MZTt@C */
    printf("Append to %s\n", lpOpts->szMztFile);
    hFileMzt = CreateFile(lpOpts->szMztFile,
      GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, 0, NULL);
    if(hFileMzt == INVALID_HANDLE_VALUE){
      lResult = GetLastError();
      DisplayErrorMessage("AppendFile", lResult);
      hFileMzt = NULL;
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    SetFilePointer(hFileMzt,0,NULL,FILE_END);//mztt@C|C^͖
    fSuccess = WriteFile(hFileMzt,
        &(lpmzt->body.bBody), lpmzt->body.dwSize, &dwWritten, NULL);
    if(fSuccess == FALSE){
      lResult = GetLastError();
      DisplayErrorMessage("WriteFile(Body)", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    dwMztSize += dwWritten;
    DebugPrintf("Size       : %u bytes\n", dwMztSize);
  }
  __finally{
    if(hFileMzt){
      CloseHandle(hFileMzt);
    }
  }
	#ifdef __BORLANDC__
	__leave:
	#endif
  return lResult;
}

/*-----------------------------------------------------------------------------
[`    ]    DecodeWaveFile
[    ]    lpOpts ... IvV
[    ]    Wavet@CfR[h
[ӎ]
[  l]    IR[h
-----------------------------------------------------------------------------*/
LRESULT DecodeWaveFile(LPOPTIONS lpOpts)
{
  LPMAPPING lpMap = NULL;
  LPMZTAPE  lpMzt = NULL;
  LRESULT   lSaveResult, lResult = ERROR_SUCCESS;
  HANDLE  hFileMzt  = NULL;	// added by koji morishita
	int blocks = 0;						// added by koji morishita

  /* Wavet@CɃ}bsO */
  if((lpMap = CreateMappingFile(lpOpts->szWaveFile)) == NULL){
    return GetLastError();
  }
  lpOpts->lpbData = lpMap->lpszFile;
  lpOpts->lpbTail = lpMap->lpszFile + lpMap->dwFileSize;
  if(lpMap->dwFileSize <= 40){  /* Wave`FbNNbV~ */
    lResult = ERROR_INVALID_DATA;
    DisplayErrorMessage(lpOpts->szWaveFile, lResult);
    return lResult;
  }
  DebugPrintf("WaveSize   : %u bytes\n", lpMap->dwFileSize);

  __try{
    lpOpts->lpbData = CheckWaveFileFormat(lpOpts->lpbData,lpOpts->lpbTail);
    if(lpOpts->lpbData == NULL){
      lResult = GetLastError();
			#ifdef __BORLANDC__
			goto
			#endif
     __leave;
    }

    /* e[vC[Wi[̈擾 */
    if((lpMzt = LocalAlloc(LPTR, sizeof(MZTAPE))) == NULL){
      lResult = GetLastError();
      DisplayErrorMessage("LocalAlloc", lResult);
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }

    /* C[Wf[^擾 */
    if((lResult = DecodeHeader(lpOpts, lpMzt)) != ERROR_SUCCESS){
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }
    // -t option blockSize=256 + checkSum=2
    if(lpOpts->fTextMode == TRUE){
      lpMzt->bodySize=lpMzt->header.wSize;  //ǉ  l̕ۑ
      lpMzt->header.wSize=TEXT_SIZE;        //ǉ  l̕ύX
    }
    lResult = DecodeBody(lpOpts, lpMzt);
		blocks=1;	// 1ubN added by koji morishita

    /* t@C */
    if((lSaveResult = CreateImageFile(lpOpts, lpMzt))!= ERROR_SUCCESS){
      lResult = lSaveResult;
			#ifdef __BORLANDC__
			goto
			#endif
      __leave;
    }

    /* -t option */
    if(lpOpts->fTextMode == TRUE){
      /* C[Wf[^擾Bwb_͂Ȃ*/
      while(1){
				blocks++;
      //  lResult = DecodeBody(lpOpts, lpMzt);
        if((lResult = DecodeBody(lpOpts, lpMzt)) != ERROR_SUCCESS){
	        /* Ō̃ubNǉ */
          AppendImageFile(lpOpts, lpMzt);

					// truncate ̂߂̃t@CI[v
		    	hFileMzt = CreateFile(lpOpts->szMztFile,
  	    		GENERIC_WRITE, 0, NULL, OPEN_ALWAYS, 0, NULL);
  	  		if(hFileMzt == INVALID_HANDLE_VALUE){
  	  		  lResult = GetLastError();
  	  		  DisplayErrorMessage("Truncate File", lResult);
  	  		  hFileMzt = NULL;
						#ifdef __BORLANDC__
						goto
						#endif
  	  		  __leave;
  	  		}
					//truncatê߂̃t@C|C^ړ
    			SetFilePointer(hFileMzt,
						((lpMzt->bodySize/256)*(TEXT_SIZE))
							+(lpMzt->bodySize%256)+CSUM_SIZE+128
								,NULL,FILE_BEGIN);
					SetEndOfFile(hFileMzt);   // do truncate
//݃oCg`FbN
/*					printf("filesize(%d)",
						((lpMzt->bodySize/256)*(TEXT_SIZE))+(lpMzt->bodySize%256)+CSUM_SIZE+128
							);
					printf("\nlpMzt->bodySize: %d", lpMzt->bodySize);
					printf("\n肴: %d",lpMzt->bodySize/256);
					printf("\nTEXT_SIZE: %d", TEXT_SIZE);
					printf("\n܂ƃwb_: %d", (lpMzt->bodySize%256)+2+128);
*/
					#ifdef __BORLANDC__
					goto
					#endif
          __leave;
        }
        /* ubNǉ */
        if((lSaveResult = AppendImageFile(lpOpts, lpMzt))!= ERROR_SUCCESS){
          lResult = lSaveResult;
					#ifdef __BORLANDC__
					goto
					#endif
          __leave;
        }
      }//while(1)
    }
  }
  __finally{
    if(lpMzt){
      LocalFree(lpMzt);
    }
    ReleaseMappingFile(lpMap);
  }
	#ifdef __BORLANDC__
	__leave:
	#endif

  return lResult;
}

/*----------------------------------------------------------------------------
[`    ]    Usage
[    ]    Ȃ
[    ]    g\
[ӎ]
[  l]    Ȃ
----------------------------------------------------------------------------*/
VOID Usage(VOID)
{
  static LPSTR lplpszUsage[] = {
    "Load.exe for EmuZ-1200 ver0.03km by TSUNEOKA shinji and modified by K.Morishita",
    "22050Hz 8rbgmŋL^ꂽWAVt@C",
    "MZ-80K/C/1200̃e[vƂă[hAmztt@C𐶐܂B\n",
    "g :load [options] <Wavefile[.wav]>",
    "\t-wn[1`16]\tf[^ǂݎPʎ (Kl:4)",
    "\t-dn[1`127]\tƂ݂Ȃl (Kl:32)",
    "\t-a\t\t[h (-r, -1, -s ̑gݍ킹)",
    "\t-r\t\tf[^̈ʑ𔽓]ĉ߂",
    "\t-s\t\tsrbg͑O̒l𗘗p(tapeload.exe݊)",
    "\t-1\t\tsrbg1Œ (l0Œ, -sIvVD)",
    "\t-b\t\trbgf[^\",
    "\t-v\t\t_vf[^\",
    "\t-F\t\twb_Ɩ{̂ʃt@Cɏo͂",
    "\t-S\t\tt@C̕\S-JISR[hg",
    "\t-D\t\tfobO[h",
    "\t-T\t\to[h",
    "\t-t\t\teLXgi\[Xj[h",
    ""
  };

  LPSTR *lplpsz = lplpszUsage;
  while(**lplpsz){
    puts(*lplpsz++);
  }
}

/*----------------------------------------------------------------------------
[`    ]    PrintOptions
[    ]    lpOpts ... IvV
[    ]    fobO[hɐݒIvV\
[ӎ]
[  l]    Ȃ
----------------------------------------------------------------------------*/
VOID PrintOptions(LPOPTIONS lpOpts)
{
  DebugPrintf("WaveFile   : %s\n", lpOpts->szWaveFile);
  DebugPrintf("OutputFile : %s, %s, %s\n",
      lpOpts->szHeaderFile, lpOpts->szBodyFile, lpOpts->szMztFile);
  DebugPrintf("Wait       : %d\n", lpOpts->iWait);
  DebugPrintf("Threshold  : %d\n", lpOpts->iThreshold);
  DebugPrintf("Hold       : %d\n", lpOpts->iHold);
  DebugPrintf("Auto       : %s\n", lpOpts->fReverse     ? "True" : "False");
  DebugPrintf("Reverse    : %s\n", lpOpts->fReverse     ? "True" : "False");
  DebugPrintf("BitSave    : %s\n", lpOpts->fBitSave     ? "True" : "False");
  DebugPrintf("DisplayBits: %s\n", lpOpts->fDisplayBits ? "True" : "False");
  DebugPrintf("DisplayDump: %s\n", lpOpts->fDisplayDump ? "True" : "False");
  DebugPrintf("DatFile    : %s\n", lpOpts->fDatFile     ? "True" : "False");
  DebugPrintf("UseS-JIS   : %s\n", _fSjis               ? "True" : "False");
  DebugPrintf("Force mode : %s\n", lpOpts->fForceMode   ? "True" : "False");
  DebugPrintf("Text mode  : %s\n", lpOpts->fTextMode    ? "True" : "False");
}

/*----------------------------------------------------------------------------
[`    ]    SetOptions
[    ]    lpOpts ... IvV
              argc   ... 
              argv   ... lXg
[    ]    R}hCݒ擾
[ӎ]
[  l]    Ȃ
----------------------------------------------------------------------------*/
LRESULT SetOptions(LPOPTIONS lpOpts, int argc, char *argv[])
{
  int iCount;

  /* Ȃ */
  if(argc < 2){
    Usage();
    return ERROR_INVALID_PARAMETER;
  }

  ZeroMemory(lpOpts, sizeof(OPTIONS));
  lpOpts->fAuto        = DEFAULT_AUTO;
  lpOpts->fReverse     = DEFAULT_REVERSE;
  lpOpts->fBitSave     = DEFAULT_BITSAVE;
  lpOpts->iHold        = DEFAULT_HOLD;
  lpOpts->fDisplayBits = DEFAULT_DISPLAYBITS;
  lpOpts->fDisplayDump = DEFAULT_DISPLAYDUMP;
  lpOpts->iWait        = DEFAULT_WAIT;
  lpOpts->iThreshold   = DEFAULT_THRESHOLD;
  lpOpts->fTextMode    = DEFAULT_TEXTMODE;
  lpOpts->fForceMode   = DEFAULT_FORCEMODE;

  /* t@C擾 */
  lstrcpy(lpOpts->szWaveFile, argv[argc-1]);
  if(*(lpOpts->szWaveFile) != '\0'){
    char szDrive[MAX_PATH], szDir[MAX_PATH];
    char szFile[MAX_PATH], szExt[MAX_PATH];
    _splitpath(lpOpts->szWaveFile, szDrive, szDir, szFile, szExt);
    if(szExt[0] == '\0'){
      lstrcat(lpOpts->szWaveFile, ".wav");
    }
    lstrcpy(lpOpts->szOutFile, szFile);
    wsprintf(lpOpts->szHeaderFile, "%s_head.dat", lpOpts->szOutFile);
    wsprintf(lpOpts->szBodyFile,   "%s_body.dat", lpOpts->szOutFile);
    wsprintf(lpOpts->szMztFile,    "%s.mzt",      lpOpts->szOutFile);
  }
  else{
    Usage();
    return ERROR_INVALID_PARAMETER;
  }

  /* IvV擾 */
  for(iCount = 1; iCount < (argc - 1); iCount++){
    LPSTR lpszOpt = argv[iCount];
    int iOpt = *(lpszOpt + 1);
    if((*lpszOpt != '-') && (*lpszOpt != '/')){
      continue;
    }
    switch(iOpt){
      case 'd':
        lpOpts->iThreshold = atoi(lpszOpt + 2);
        if((lpOpts->iThreshold < 1) || (lpOpts->iThreshold > 127)){
          LRESULT lResult = ERROR_INVALID_PARAMETER;
          DisplayErrorMessage(lpszOpt, lResult);
          return lResult;
        }
        break;
      case 'w':
        lpOpts->iWait = atoi(lpszOpt + 2);
        if((lpOpts->iWait < 1) || (lpOpts->iWait > 16)){
          LRESULT lResult = ERROR_INVALID_PARAMETER;
          DisplayErrorMessage(lpszOpt, lResult);
          return lResult;
        }
        break;
      case '1':
        lpOpts->iHold = BIT_H;
        break;

      case 'a':
        lpOpts->fAuto = TRUE;
        break;
      case 'r':
        //lpOpts->fReverse = TRUE;
        lpOpts->fReverse = FALSE;
        break;
      case 's':
        lpOpts->fBitSave = TRUE;
        break;
      case 'b':
        lpOpts->fDisplayBits = TRUE;
        break;
      case 'v':
        lpOpts->fDisplayDump = TRUE;
        break;

      case 'F':
        lpOpts->fDatFile = TRUE;  /* ʃt@Co */
        break;
      case 'D':
        _fDebug = TRUE;   /* Debug[h */
        break;
      case 'S':
        _fSjis = TRUE;    /* MZt@C2oCgR[hŕ\ */
        break;
      case 't':
        lpOpts->fTextMode = TRUE; /* TextMode */
        break;
      case 'T':
        lpOpts->fForceMode = TRUE; /* ForceMode */
        break;
      default:
        break;
    }
  }
  return ERROR_SUCCESS;
}

/*----------------------------------------------------------------------------
[`    ]    AutoMode
[    ]    lpOpts ... IvV
[    ]    ʓIȃIvV̑gݍ킹
[ӎ]
[  l]    Ȃ
----------------------------------------------------------------------------*/
LRESULT AutoMode(LPOPTIONS lpOpts)
{
  LRESULT lResult = ERROR_SUCCESS;

  printf("Bit Hold Low\n");
  lpOpts->fBitSave = FALSE;
  lpOpts->fReverse = FALSE;
  lpOpts->iHold    = BIT_L;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }
  if((lResult != ERROR_INVALID_DATA) && (lResult != ERROR_NO_MORE_ITEMS)){
    return lResult;
  }

  printf("Bit Hold Low, Reverse\n");
  lpOpts->fReverse = TRUE;
  lpOpts->iHold    = BIT_L;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }

  printf("Bit Hold Hi\n");
  lpOpts->fReverse = FALSE;
  lpOpts->iHold    = BIT_H;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }

  printf("Bit Hold Hi, Reverse\n");
  lpOpts->fReverse = TRUE;
  lpOpts->iHold    = BIT_H;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }

  printf("Bit Save\n");
  lpOpts->fBitSave = TRUE;
  lpOpts->fReverse = FALSE;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }

  printf("Bit Save, Reverse\n");
  lpOpts->fBitSave = TRUE;
  lpOpts->fReverse = TRUE;
  if((lResult = DecodeWaveFile(lpOpts)) == ERROR_SUCCESS){
    return lResult;
  }

  return lResult;
}

/*-----------------------------------------------------------------------------
  C
-----------------------------------------------------------------------------*/
int main(int argc, char *argv[])
{
  OPTIONS opts;
  LRESULT lResult = ERROR_SUCCESS;

  if((lResult = SetOptions(&opts, argc, argv)) != ERROR_SUCCESS){
    return lResult;
  }
  PrintOptions(&opts);

  if(opts.fAuto == TRUE){
    lResult = AutoMode(&opts);
  }
  else{
    lResult = DecodeWaveFile(&opts);
  }

  return lResult;
}
